
import sq4d.all;
import std.stdio;
import std.c.stdarg;
import std.c.stdio;
import std.exception;



extern(C) void myprintfunc(HSQUIRRELVM sq, const(SQChar)* fmt, ...) {
    //printf("printfunc\n");
    va_list args;
    va_start(args, fmt);
    vfprintf(core.stdc.stdio.stdout, fmt, args);
    va_end(args);
}
extern(C) void myerrorfunc(HSQUIRRELVM sq, const(SQChar)* fmt, ...) {
    //printf("errorfunc\n");
    va_list args;
    va_start(args, fmt);
    vfprintf(core.stdc.stdio.stderr, fmt, args);
    va_end(args);
}






int hoge(int i, int j) {
    writeln("ij = ", i, j);
    return i*100+j;
}


extern(C) SQInteger sqhoge(HSQUIRRELVM sq) {
    auto pf = sq_getprintfunc(sq);
    pf(sq, "sqhoge call\n");
    sqd_printstack(sq);
    return 0;
}

class C {
    void hoge() {
        writeln("hoge");
    }
    int hogehoge(int i, int j, int k, int l) {
        writeln("hogehoge ", i, ", ", j);
        return i * (j+100);
    }
    int mem=100;
}

void main() {
    HSQUIRRELVM sq = sq_open(16);
    scope(exit) sq_close(sq);
    sq_pushroottable(sq);
    
    //register funcs
    sq_setprintfunc(sq, &myprintfunc, &myerrorfunc);
    sqstd_register_bloblib(sq);
    sqstd_register_iolib(sq);
    sqstd_register_systemlib(sq);
    sqstd_register_mathlib(sq);
    sqstd_register_stringlib(sq);
    sqstd_seterrorhandlers(sq);
    
    //sq_pushnull(sq);
    //sqd_newslot(sq, "hoge", &SQFuncWrap!hoge);
    //roottable["hoge"] = &SQFuncWrap!hoge;
    sq_pushroottable(sq);
    auto roottable = SquirrelObject.makePop(sq);
    sq_pushroottable(sq);
    auto c = new C;
    auto c2 = new C;
    roottable["myc"] = c;
    roottable["myc2"] = c2;
    
    auto sqf = sqd_wrapfunction!hoge(sq);
    roottable["hoge"] = sqf;
    auto f = roottable["hoge"];
    writeln("root[hoge] = ", f.toString());
    
    sqd_printstack(sq);
    writeln("top1: ", sq_gettop(sq));
    //const(SQChar)* src = "test.nut\0";
    const(SQChar)* src = "fibertest.nut\0";
    sqstd_dofile(sq, src, SQTrue, SQTrue);
    sqd_printstack(sq);
    sq_pop(sq, 1); // retval
    
    writeln("top2: ", sq_gettop(sq));
    sqd_dostring(sq, "return (1 + 2) + \"hoge\";");
    sqd_printstack(sq);
    sq_pop(sq, 1); // retval
    
    writeln("top3: ", sq_gettop(sq));
    sqd_printstack(sq);
    auto println = roottable["println"];
    println.call("hoge");
    //writeln("ret = ", ret.toString());
    sqd_printstack(sq);

    {
        auto t = roottable.get!(Tuple!(double, double, double))("tp");
        writeln(t[0], ", ", t[1], ", ", t[2]);
        writeln(roottable.get!double("tp2"));
    }

    writeln("uwagaki");
    writeln(println.toString());
    println = roottable["print"];
    writeln(println.toString());
    writeln("uwagaki2");
    sqd_printstack(sq);
    auto myc = roottable["myc"];
    myc.callMethod("hogehoge", 10, 200, 1, 2);
    //roottable.callMethod("println", "hoge");
    sqd_printstack(sq);
    
}
